Bug 861306 - Stopping the volume does not clear the locks
Stopping the volume does not clear the locks
Status: CLOSED WORKSFORME
Product: GlusterFS
Classification: Community
Component: locks (Show other bugs)
3.3.0
Unspecified Unspecified
high Severity unspecified
: ---
: ---
Assigned To: Pranith Kumar K
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-28 02:01 EDT by Joe Julian
Modified: 2012-12-12 01:53 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-12 01:53:05 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Joe Julian 2012-09-28 02:01:41 EDT
Description of problem:
I recently replaced a server and sefl-heal was hanging on some files. Eventually I discovered that the files it was hanging on were locked. In an attempt to clear the locks as there were too many to clear using the cli (at 45 seconds per lock it would have taken forever), I stopped and started the volume.

Unfortunately, the clients apparently retained the locks and re-propagated them to the servers when I started the volume again.

The only solution was to stop every client, stop and start the volume and then let them all back in.

Version-Release number of selected component (if applicable):
3.3.0

How reproducible:
Always

Steps to Reproduce:
1. Have inode and/or entry locks
2. Stop the volume
3. Start the volume
  
Actual results:
The locks persist

Expected results:
The locks should have been cleared.

Additional info:
Comment 1 Pranith Kumar K 2012-11-11 23:09:35 EST
Working as expected for me. Am I missing something?

[root@pranithk-laptop ~]# grep GRANTED /tmp/gfs-r2_*
[root@pranithk-laptop ~]# less /tmp/gfs-r2_0.29011.dump 
[root@pranithk-laptop ~]# grep ACTIVE /tmp/gfs-r2_*
/tmp/gfs-r2_0.29011.dump:inodelk.inodelk[0](ACTIVE)=type=WRITE, whence=0, start=89639424, len=6144, pid = 774640124, owner=fc112c2ef67f0000, transport=0x1241570, , granted at Mon Nov 12 09:39:47 2012
/tmp/gfs-r2_0.29011.dump:inodelk.inodelk[0](ACTIVE)=type=WRITE, whence=0, start=89639424, len=6144, pid = 774640124, owner=fc112c2ef67f0000, transport=0x1241570, , granted at Mon Nov 12 09:39:47 2012
/tmp/gfs-r2_1.29017.dump:inodelk.inodelk[0](ACTIVE)=type=WRITE, whence=0, start=92708352, len=3072, pid = 774621368, owner=b8c82b2ef67f0000, transport=0x14bf570, , granted at Mon Nov 12 09:39:49 2012
/tmp/gfs-r2_1.29017.dump:inodelk.inodelk[1](ACTIVE)=type=WRITE, whence=0, start=92703232, len=5120, pid = 774652628, owner=d4422c2ef67f0000, transport=0x14bf570, , granted at Mon Nov 12 09:39:49 2012
/tmp/gfs-r2_1.29017.dump:inodelk.inodelk[0](ACTIVE)=type=WRITE, whence=0, start=92708352, len=3072, pid = 774621368, owner=b8c82b2ef67f0000, transport=0x14bf570, , granted at Mon Nov 12 09:39:49 2012
/tmp/gfs-r2_1.29017.dump:inodelk.inodelk[1](ACTIVE)=type=WRITE, whence=0, start=92703232, len=5120, pid = 774652628, owner=d4422c2ef67f0000, transport=0x14bf570, , granted at Mon Nov 12 09:39:49 2012
[root@pranithk-laptop ~]# gluster volume stop r2
Stopping volume will make its data inaccessible. Do you want to continue? (y/n) y
Stopping volume r2 has been successful
[root@pranithk-laptop ~]# gluster volume start r2
Starting volume r2 has been successful
[root@pranithk-laptop ~]# gluster volume statedump r2^C
[root@pranithk-laptop ~]# rm -f /tmp/gfs-r2_*
[root@pranithk-laptop ~]# gluster volume statedump r2
Volume statedump successful
[root@pranithk-laptop ~]# grep ACTIVE /tmp/gfs-r2_*
[root@pranithk-laptop ~]#

Note You need to log in before you can comment on or make changes to this bug.